import java.io.*;

public class CipheringDeciphering {
	protected char[][] table;   //The table is created below and stored in this 2-dimensional character array.
	protected char[] keywordArray;  //The String keyword is converted to a character array for better utilization.
	protected int i , j, k=0;  //Internal temporary variables used in the creation of the table.
	protected int keywordLength;  //Used for the coversion of the keyword type from String to Character Array

	// The following 6 objects are defined for use in setting up the mechanism by which 
	//we read from file (the first 3) and write to a file on disk (the last 3). 
	protected FileInputStream fileInStream;
	protected InputStreamReader inputReader;
	protected BufferedReader bufReader;
	protected FileOutputStream fileOutStream;
	protected OutputStreamWriter outputWriter;
	protected BufferedWriter bufWriter;

	//This is the constructor of this class. The procedures within are automatically executed 
	//upon creation of the objects of type Ciphering and Deciphering, which are derived from this class.
	protected CipheringDeciphering(String filename, String keyword)throws FileNotFoundException,IOException{
		super();

		keywordLength = keyword.length();
		keywordArray = keyword.toCharArray();
			
		fileInStream =new FileInputStream(filename);
		inputReader = new InputStreamReader(fileInStream);
		bufReader = new BufferedReader(inputReader);

		// Table creation procedure and saving it in the variable "table" defined above 
			
		table = new char[128][128];
				for (i=0; i<table.length; i++)
					{
						for(j=0; j<table[i].length; j++)
							{
								if( (k+j) >= 128)
									table[i][j] =(char)(j+k-128);
								else
									table[i][j]=(char)(j+k);
							}
						k++;	
					}
		}

}
